#include <stdio.h>
#include <string.h>
#include <dir.h>

const char *magic = "WAD2";

FILE *in, *out;

struct a {
  char name[12];
  long offs;
  long size;
} table[700];

void writefile(char *name)
{
  unsigned char buf;
  in = fopen(name, "rb");
  if (!in) return;
  printf("Adding %s...\n", name);

  buf = getc(in);

  while (!feof(in))
  {
    putc(buf, out);
    buf = getc(in);
  }

  fclose(in);
}

int main(int argc, char *argv[])
{
  int done, n = 0;
  unsigned long offset = 8;
  ffblk ffblk;
  char buf[100];

  if (argc < 3) return 1;

  strcpy(buf, argv[2]);
  strcat(buf, "\\*.*");
  done = findfirst(buf, &ffblk, 15);

  if (!done)
  {
    out = fopen(argv[1], "wb");
    if (!out) return 1;
    fwrite((char *)magic, 8, 1, out);
  }

  while (!done)
  {
    strcpy(buf, argv[2]);
    strcat(buf, "\\");
    strcat(buf, ffblk.ff_name);
    strcpy(table[n].name, ffblk.ff_name);
    table[n].offs = offset;
    table[n].size = ffblk.ff_fsize;
    n++;
    offset += ffblk.ff_fsize;
    writefile(buf);
    done = findnext(&ffblk);
  }

  fwrite(table, sizeof(a), n, out);
  fseek(out, 4, 0);
  fwrite(&offset, 4, 1, out);

  fclose(out);
}
